/*
 * VMGFragmentController.hpp
 *
 *  Created on: Aug 27, 2012
 *      Author: heber
 */

#ifndef VMGFRAGMENTCONTROLLER_HPP_
#define VMGFRAGMENTCONTROLLER_HPP_


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "Fragmentation/Automation/SpecificFragmentController.hpp"

#include "JobMarket/JobId.hpp"

#include "Fragmentation/SetValues/Fragment.hpp"
#include "Jobs/Grid/SamplingGrid.hpp"
#include "Jobs/MPQCData.hpp"
#include "Jobs/VMGData.hpp"

/** This class uses SpecificFragmentController with functions to add specificly
 * VMGJobs.
 */
class VMGFragmentController : public SpecificFragmentController
{
public:
  VMGFragmentController(boost::asio::io_service &io_service) :
    SpecificFragmentController(io_service)
  {}
  virtual ~VMGFragmentController()
  {}

  bool createLongRangeJobs(
      const std::map<JobId_t, MPQCData> &fragmentData,
      const SamplingGrid &full_sampled_grid,
      const Fragment &full_fragment);
  void getResults(std::map<JobId_t, VMGData> &fragmentData) {
    SpecificFragmentController::getResults<VMGData>(fragmentData);
  }
};


#endif /* VMGFRAGMENTCONTROLLER_HPP_ */
